<template>
  <b-popover
    v-if="(!valid && validationResults.length > 0) || !isEntryNameUrlSafe"
    over
    target="metadataManagerButtonCol"
    triggers="hover focus"
    placement="top"
  >
    <template #title>
      <b>{{ $t("page.resource.validationErrors") }}</b>
    </template>
    <div>
      <ul>
        <li
          v-for="validationResult of validationResults"
          :key="validationResult.term"
        >
          <p class="validationPathHeader">
            {{ validationResult.path ? validationResult.path : "" }}:
          </p>
          <ul>
            <li
              v-for="singleMessage of validationResult.message"
              :key="singleMessage"
            >
              {{ singleMessage }}
            </li>
          </ul>
        </li>
        <li v-if="!isEntryNameUrlSafe">
          {{ $t("page.resource.metadataManagerBadFileName") }}
        </li>
      </ul>
    </div>
  </b-popover>
</template>

<script lang="ts">
export default defineComponent({
  props: {
    isEntryNameUrlSafe: {
      default: true,
      type: Boolean,
    },
    valid: {
      required: true,
      type: Boolean,
    },
    validationResults: {
      required: true,
      type: Array as PropType<
        {
          message: string[];
          term: string;
          path: string;
        }[]
      >,
    },
  },
});
</script>

<style scoped>
.validationPathHeader {
  font-weight: bold;
}
</style>
